<template>
  <div class="app-container">
    <el-card>
      <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="100px">
        <el-form-item label="转运日期" prop="timeRange">
          <el-date-picker
            v-model="queryParams.timeRange"
            type="daterange"
            value-format="yyyy-MM-dd"
            range-separator="至"
            start-placeholder="开始日期"
            end-placeholder="结束日期"
            :picker-options="pickerOptions"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item label="转运批次号" prop="harmlessTreatmentId">
          <el-input
            v-model="queryParams.harmlessTreatmentId"
            placeholder="请输入转运批次号"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>
      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button
            type="primary"
            plain
            icon="el-icon-plus"
            size="mini"
            @click="handleAdd"
            v-hasPermi="['app:transport:add']"
          >新增</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="danger"
            plain
            icon="el-icon-delete"
            size="mini"
            :disabled="multiple"
            @click="handleDeleteAll"
            v-hasPermi="['app:transport:remove']"
          >删除</el-button>
        </el-col>
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>
    </el-card>
    <br>
    <el-card>
      <el-table border stripe height="600" v-loading="loading" ref="multipleTable" :data="disposalList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55"  />
        <!--  <el-table-column label="ID"  prop="id" width="80" />  -->
        <el-table-column label="转运日期"  prop="transportTime" />
        <el-table-column label="转运批次号"  prop="harmlessTreatmentId" />
        <el-table-column label="转运数量"  prop="illnessAmount" >
          <template slot-scope="scope">
            <span>{{scope.row.illnessAmount}}</span>
          </template>
        </el-table-column>
        <el-table-column label="转运产品重量"  prop="unqualifiedWeight" >
          <template slot-scope="scope">
            <span>{{scope.row.unqualifiedWeight}}kg</span>
          </template>
        </el-table-column>
        <el-table-column label="目的地"  prop="destination" />
        <el-table-column label="车牌号码"  prop="carNum" />
        <el-table-column label="联系人"  prop="userName" />
        <el-table-column label="联系电话"  prop="phone" />
        <el-table-column label="责任人"  prop="responsibilityUser" />
        <el-table-column label="操作" width="180"  class-name="small-padding fixed-width">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleView(scope.row)"
            >查看</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              @click="handleUpdate(scope.row)"
              v-hasPermi="['app:transport:edit']"
              style="margin-right: 10px"
            >修改</el-button>
            <el-popconfirm
              v-hasPermi="['app:transport:remove']"
              :title="'是否确认删除所选数据项？'"
              @confirm="handleDelete(scope.row)"
            >
              <el-button
                size="mini"
                type="text"
                slot="reference"
                icon="el-icon-delete"
              >删除</el-button>
            </el-popconfirm>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
    </el-card>

    <!-- 添加或修改死淘处理方式对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="550px" append-to-body>
      <el-form ref="form" label-position="left" :model="form" :rules="rules" :disabled="isView" label-width="120px">
        <el-form-item label="转运日期" prop="transportTime">
          <el-date-picker
            style="width: 100%"
            v-model="form.transportTime"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择日期时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="暂存批次号">
          <el-select v-model="form.harmlessTreatmentList" :disabled="form.id !== null" multiple style="width: 100%;">
            <el-option v-for="(item, i) in harmlessList" :key="i" :value="item.harmlessTreatmentId" :label="item.harmlessTreatmentId"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item  label="转运数量" prop="illnessAmount">
          <el-input v-model.number="form.illnessAmount" disabled :placeholder="isView ? '' : '自动填充'"></el-input>
        </el-form-item>
        <el-form-item  label="转运产品重量" prop="unqualifiedWeight">
          <el-input v-model="form.unqualifiedWeight" disabled type="number" :placeholder="isView ? '' : '自动填充'">
            <template #append>kg</template>
          </el-input>
        </el-form-item>
        <el-form-item  label="目的地" prop="destination">
          <el-input v-model="form.destination" type="textarea" :autosize="{ minRows: 2 }" show-word-limit maxlength="50" placeholder="请输入目的地"></el-input>
        </el-form-item>
        <el-form-item  label="车辆号码" prop="carNum">
          <el-input v-model="form.carNum"  placeholder="请输入车辆号码"></el-input>
        </el-form-item>
        <el-form-item  label="联系人" prop="userName">
          <el-input v-model="form.userName" :placeholder="isView ? '' : '请输入联系人'" show-word-limit maxlength="10"></el-input>
        </el-form-item>
        <el-form-item  label="联系电话" prop="phone">
          <el-input v-model="form.phone" :placeholder="isView ? '' : '请输入联系电话'"></el-input>
        </el-form-item>
        <el-form-item  label="责任人" prop="responsibilityUser">
          <el-input v-model="form.responsibilityUser" placeholder="请输入责任人" show-word-limit maxlength="10"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer" v-if="!isView">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
// import { getHarmlessList } from "../../../api/app/harmless";
// import { getTransportPage, getTransportDetail, addTransportPage, editTransportPage, delTransportPage, getTsAll } from "../../../api/app/transport";
import {changeDate, formatDate, getFindByKey} from "../../../utils";
import { required, rules } from "../../../utils/formRules";
// import {getUserProfile} from "../../../api/system/user";

export default {
  name: "",
  data() {
    var validatePhone = (rule, value, callback) => {
      if (value === undefined || value === null || value.trim() === '') {
        callback();
      } else {
        let phoneRegex = /^(13[0-9]|14[579]|15[0-3,5-9]|16[6]|17[0135678]|18[0-9]|19[89])\d{8}$/
        if(!phoneRegex.test(value)) {
          callback(new Error('请填写正确的手机格式'));
        } else {
          callback()
        }
      }

    };
    // 验证15位数字
    const validateNumber = (rule, value, callback) => {
      if (!/^([1-9]\d*(\.\d{1,2})?|0\.(\d[1-9]|[1-9]\d))$/.test(value)) {
        callback(new Error('必须是正数且最多两位小数'));
      } else {
        callback();
      }
    };
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 表格数据
      disposalList: [],
      // 弹出层标题
      title: "",
      isView:false,
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        timeRange: null,
        harmlessTreatmentId: null,
        startTime: null,
        endTime: null
      },
      pickerOptions: {
        disabledDate(time) {
          // 获取当前日期
          const today = new Date();
          today.setHours(0, 0, 0, 0); // 将时间设置为当天的 00:00:00

          // 禁用今天之后的日期
          return time.getTime() > today.getTime();
        }
      },
      // 表单参数
      form: {
        carNum: null,
        harmlessTreatmentId: null,
        id: null,
        illnessAmount: null,
        transportTime: changeDate(new Date()),
        unqualifiedWeight: null,
        userName: null,
        phone: null,
        destination: null,
        responsibilityUser: null,
        harmlessTreatmentList: [],
        harmlessTreatmentIds: null,
        unit: null
      },
      rules: {
        carNum: [required('车辆号码不能为空'), rules.carNum],
        transportTime: [required('转运日期不能为空')],
        // harmlessTreatmentId: [required('无害化批次号不能为空')],
        destination: [required('目的地不能为空')],
        responsibilityUser: [required('责任人不能为空')],
        phone: [{ validator: validatePhone,  trigger: 'blur'}],
        illnessAmount: [
          {
            validator: (rule, value, callback) => {
              if (!value) {
                // 如果没填，直接通过
                return callback();
              }
              validateNumber(rule, value, callback);
            },
            trigger: 'blur'
          }
        ],
        unqualifiedWeight: [
          {
            validator: (rule, value, callback) => {
              if (!value) {
                // 如果没填，直接通过
                return callback();
              }
              validateNumber(rule, value, callback);
            },
            trigger: 'blur'
          }
        ]
      },
      harmlessList: [],
      user: {},
    }
  },
  watch: {
    "queryParams.timeRange": {
      handler(newVal) {
        if (newVal) {
          this.queryParams.startTime = newVal[0]
          this.queryParams.endTime = newVal[1]
        } else {
          this.queryParams.startTime = null
          this.queryParams.endTime = null
        }
      },
      deep: true
    },
    "form.harmlessTreatmentId": {
      handler(newVal) {
        if (newVal) {
          let item = getFindByKey(this.harmlessList, newVal, 'id')
          if (item) {
            this.form.illnessAmount = item.illnessAmount
            this.form.unqualifiedWeight = item.unqualifiedWeight
          }
        } else {
          this.form.illnessAmount = null
          this.form.unqualifiedWeight = null
        }
      },
      deep: true
    },
    "form.harmlessTreatmentList": {
      handler(newVal) {
        if(this.form.id !== null) {
          return
        }
        if(newVal) {
          let illnessAmount = 0;
          let unqualifiedWeight = 0;
          for(let i = 0; i<this.harmlessList.length; i++) {
            for(let j = 0; j<newVal.length; j++) {
              if(this.harmlessList[i].harmlessTreatmentId === newVal[j]) {
                illnessAmount += this.harmlessList[i].illnessAmount === null ? 0 : Number(this.harmlessList[i].illnessAmount)
                unqualifiedWeight += this.harmlessList[i].unqualifiedWeight === null ? 0 : Number(this.harmlessList[i].unqualifiedWeight)
              }
            }
          }
          this.form.illnessAmount = illnessAmount
          this.form.unqualifiedWeight = unqualifiedWeight
        } else {
          this.form.illnessAmount = null
          this.form.unqualifiedWeight = null
        }
      }
    }
  },
  created() {
    this.loading = false
    // this.getUser()
    // this.getHarmlessList()
    // this.getList();
  },
  methods: {
    /** getUser **/
    getUser() {
      getUserProfile().then(response => {
        this.user = response.data;
        this.form.responsibilityUser = response.data.nickName
      });
    },
    /** 无害化批次号列表 **/
    getHarmlessList() {
      getTsAll({}).then(res => {
        let list = []
        res.data.forEach(item => {
          if(item.isLeave === 0) {
            list.push(item)
          }
        })
        this.harmlessList = list
      })
    },
    /** 查询检验项目列表 */
    getList() {
      getTransportPage(this.queryParams).then(res => {
        res.data.records.forEach(item => {
          item.transportTime = changeDate(item.transportTime)
        })
        this.disposalList = res.data.records;
        this.total = res.data.total;
        this.loading = false;
      })
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.queryParams = {
        pageNum: 1,
        pageSize: 10,
        timeRange: null,
        harmlessTreatmentId: null,
        startTime: null,
        endTime: null
      }
      // this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.getHarmlessList();
      this.reset();
      this.open = true;
      this.isView = false;
      this.title = "添加无害化转运";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      let params = {
        id: id
      }
      getTransportDetail(params).then(res => {
        this.form = res.data;
        this.form.harmlessTreatmentList = this.form.harmlessTreatmentIds.split(',')
        this.open = true;
        this.isView = false;
        this.title = "修改无害化转运";
      })
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.reset();
      const id = row.id;
      let params = {
        id: id
      }
      getTransportDetail(params).then(res => {
        this.form = res.data;
        this.form.harmlessTreatmentList = this.form.harmlessTreatmentIds.split(',')
        this.open = true;
        this.isView = true;
        this.title = "查看无害化转运";
      })
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        carNum: null,
        harmlessTreatmentId: null,
        id: null,
        illnessAmount: null,
        transportTime: changeDate(new Date()),
        unqualifiedWeight: null,
        userName: null,
        phone: null,
        destination: null,
        responsibilityUser: this.user.nickName,
        unit: null,
        harmlessTreatmentList: [],
        harmlessTreatmentIds: null,
      };
      this.resetForm("form");
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form.harmlessTreatmentIds = this.form.harmlessTreatmentList.join(',')
          if (this.form.id != null) {
            // 编辑
            editTransportPage(this.form).then(res => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            })
          } else {
            // 新增
            addTransportPage(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id;
      let params = {
        ids: ids
      }
      delTransportPage(params).then(res => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      })
    },
    /** 删除按钮操作 */
    handleDeleteAll() {
      const ids = this.ids;
      this.$modal.confirm('是否确认删除所选数据项？').then(() => {
        let params = {
          ids: ids.join(',')
        }
        delTransportPage(params).then(res => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
          this.$refs.multipleTable.clearSelection();
        })
      })
    }
  }
}
</script>

<style scoped lang="scss">

</style>

